#ifndef PARTICLE_H_
#define PARTICLE_H_

#include "vector.h"

typedef Vector3 Color;

class Particle {
public:
	Vector3 pos;		/* position */
	Vector3 prev_pos;
	Vector3 v;			/* velocity */
	double spawn_time;
	Color color;		/* current color*/
	double alpha;
	double size;

	Particle();
	void set_start_position(const Vector3 &pos, double radius);
	void set_start_velocity(const Vector3 &start_vel, double angle);
};

void billboard(const Vector3 &v, const Color &col, double alpha, double sz);

#endif
