#ifndef VECTOR_H_
#define VECTOR_H_

class Matrix4x4;

class Vector3 {
public:
	double x,y,z;
	Vector3();
	Vector3(double x, double y, double z);
	void transform(const Matrix4x4 &tm);
	void printv();
};

bool operator < (const Vector3 &a, const Vector3 &b);
bool operator > (const Vector3 &a, const Vector3 &b);

Vector3 operator + (const Vector3 &a, const Vector3 &b);
Vector3 operator - (const Vector3 &a, const Vector3 &b);
Vector3 operator - (const Vector3 &a);
Vector3 operator * (const Vector3 &a, const Vector3 &b);
Vector3 operator * (const Vector3 &a, double b);
Vector3 operator * (double b, const Vector3 &a);
Vector3 operator / (const Vector3 &a, double b);

const Vector3 &operator += (Vector3 &a, const Vector3 &b);

double length (const Vector3 &a);
double dot (const Vector3 &a, const Vector3 &b);
Vector3 cross (const Vector3 &a, const Vector3 &b);
Vector3 normalize (const Vector3 &a);

Vector3 reflect(const Vector3 &v, const Vector3 &n);

#endif

